%%HP: T(3)A(R)F(.);

\<<

\<<
 \-> A D DO\->Q
\<< A TYPE \-> T \<<
  CASE T 0 ==
	THEN A D 

@ NEW2Q: Version of ->Q based on J.K.Horn's Algorithm
@
@ Input:
@
@ 2: Decimal Number to be converted to a fraction
@ 1: Number of decimal places of zeros required in the error.
@
@ Output:
@
@ 1: 'Numerator/Denominator'
@
@ Example:
@
@ What's the simplest fraction which agrees with sqrt(3) to 4 decimal places?
@   3 \sqr 4 NEQ2Q returns '97/56'
@   '97/56-\sqr(3)' EVAL returns .00009294957
@                                 ^^^^  note 4 zeros.
@
@ Checksum and bytes:
@   #3992d
@   620.5

@ \<<
 DUP2
  IF 1 > SWAP FP AND
  THEN OVER XPON 1 -                        @ calculate the input exponent.
    \<< \-> X 'IFTE(X==0,-500,XPON(X))' \>> @ define a 0-tolerant XPON.
  \-> f c x expo
    \<< 0 1 1 f DUP IP SWAP FP              @ set recursion initial cond.s.
      WHILE
       OVER 5 PICK / f - ABS expo EVAL      @ calculate expon. of error
       x SWAP - c <                         @ and compare with input.
       OVER AND                             @ if not close enough and
                                            @ the remainder's non-zero
      REPEAT
       INV DUP FP SWAP IP                   @ then calculate next iterate.
       \-> B0 B1 A0 A1 R B
        \<< B1 'B*B1+B0' EVAL
            A1 'B*A1+A0' EVAL
            R
        \>>
      END
      DROP SWAP DROP SWAP
      DUP 4 ROLL - DUP f * 0 RND            @ calc. "missing" den. and num.
      \-> N D D0 N0
      \<<
@       IF 'x-expo(ABS(f-N0/D0))<c'        @@ if "missing" frac. is not
@       THEN N D                           @@ good enough, use original.
@       ELSE N0 D0
@         IF 'N0\=/N'                      @@ If it is really new,
@         THEN 200 .2 BEEP                 @@ then beep.
@         END
@        END
        IF D0
        THEN
          IF 'x-expo(ABS(f-N0/D0))<c'
          THEN N D
          ELSE N0 D0
            IF 'N0\=/N'
            THEN 200 .2 BEEP
            END
          END
        ELSE N D
        END
@
      \>>
    \>>                                     @ We're done, now clean up.
    IF DUP ABS 1 >
@   THEN # 352318d SYSEVAL
    THEN DUP2 * SIGN ROT ABS ROT ABS # 5603Eh SYSEVAL *
@
    ELSE DROP
    END
  ELSE DROP
  END
@ \>>



 END
	T 9 == THEN A OBJ\-> \-> n oper \<<
	1 n START D DO\->Q
 DUP EVAL
 n ROLL NEXT

	oper
	n 1 + # 18CEAh SYSEVAL		@ n+1 as system binary
	# 546Dh SYSEVAL			@ join as algebraic

 \>>
	END
	T 1 == THEN A RE D DO\->Q
 DUP EVAL
 A IM D DO\->Q
 DUP EVAL
 i * + END
	T 5 == THEN A OBJ\-> \-> n \<< 1 n
	START D DO\->Q
 DUP EVAL
 n ROLL NEXT
	n \->LIST \>>
	END
	T 12 == THEN
	A OBJ\-> SWAP D DO\->Q
 DUP EVAL
 SWAP \->TAG END
	A
  END
\>> \>> \>>

DUP EVAL
@  \-> DQ
@  \<< DQ DQ EVAL
@  \>>
\>>
